#include <iostream.h>
#include <allegro.h>
#include "eb_pong.h"


BITMAP *pages[2];
int page=0;
int p1points;
int p2points;

void print_points(int side) {
	textprintf(pages[page],font,140,6,0,"%d",p1points);
	textprintf(pages[page],font,379,6,0,"%d",p2points);
}


void wmain() {
	BITMAP *temp;
	BITMAP *background;
	PALLETE pal;

	allegro_init();
	install_keyboard();
	install_timer();

	text_mode(-1);

	set_gfx_mode(GFX_DIRECTX_ACCEL,640,480,0,0);
	pages[0] = create_video_bitmap(640,480);
	pages[1] = create_video_bitmap(640,480);
	background = create_video_bitmap(640,480);
		clear(pages[0]);
		clear(pages[1]);

	ball the_ball;
	paddle paddles[2];

	the_ball.reset_ball(0);

	temp=load_bitmap("back256.bmp",pal);
	set_pallete(pal);
	blit(temp,background,0,0,0,0,640,480);
	destroy_bitmap(temp);

	while (!key[KEY_ESC]) {
		if (key[KEY_Q]) {
			paddles[0].paddle_up();
		}
		if (key[KEY_A]) {
			paddles[0].paddle_down();
		}
		if (key[KEY_P]) {
			paddles[1].paddle_up();
		}
		if (key[KEY_L]) {
			paddles[1].paddle_down();
		}
		acquire_bitmap(pages[page]);
		acquire_bitmap(background);
		blit(background,pages[page],0,0,0,0,640,480);
		release_bitmap(background);
		paddles[0].draw_paddle(0);
		paddles[1].draw_paddle(1);
		the_ball.update_ball();
		the_ball.bounce_ball(paddles[0].y_pos,&the_ball);
		the_ball.bounce_ball(paddles[1].y_pos,&the_ball);
		the_ball.draw_ball();
		print_points(0);
		print_points(1);
		release_bitmap(pages[page]);
		show_video_bitmap(pages[page]);
		page = 1-page;
	}

	the_ball.~ball();
	paddles[0].~paddle();
	paddles[1].~paddle();
	destroy_bitmap(pages[0]);
	destroy_bitmap(pages[1]);
	destroy_bitmap(background);
}